## ros-melodic-novatel-oem7-driver 1.1.0

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.3)
project(novatel_oem7_driver)

## Compile as C++11, supported in ROS Kinetic and newer
add_compile_options(-std=c++11)

set(BUILD_DEPS
  nodelet
  roscpp
  std_msgs
  gps_common
  sensor_msgs
  tf
  message_generation
  novatel_oem7_msgs
)



find_package(catkin 			REQUIRED COMPONENTS ${BUILD_DEPS})
find_package(Boost  			REQUIRED COMPONENTS system thread)


catkin_package(
  INCLUDE_DIRS include
  LIBRARIES ${PROJECT_NAME}
)

# Make package available as a macro to C++
add_definitions("-D${PROJECT_NAME}_VERSION=\"${${PROJECT_NAME}_VERSION}\"")

###########
## Build ##
###########

include_directories(include
    ${catkin_INCLUDE_DIRS}
    ${Boost_INCLUDE_DIRS}
    ${novatel_oem7_msgs_INCLUDE_DIRS}
    "novatel_oem7/include"
    src
)



## All components are plugins
add_library(${PROJECT_NAME}
   src/oem7_log_nodelet.cpp
   src/oem7_message_nodelet.cpp
   src/oem7_config_nodelet.cpp
   src/oem7_receiver_net.cpp
   src/oem7_receiver_port.cpp
   src/oem7_receiver_file.cpp
   src/oem7_message_decoder.cpp
   src/oem7_message_util.cpp
   src/oem7_ros_messages.cpp
   src/message_handler.cpp
   src/bestpos_handler.cpp
   src/ins_handler.cpp
   src/align_handler.cpp
   src/time_handler.cpp
   src/receiverstatus_handler.cpp
)


add_dependencies(${PROJECT_NAME} ${${PROJECT_NAME}_EXPORTED_TARGETS} ${catkin_EXPORTED_TARGETS})

# Link to i386 or amd64 version of the Decoder. ARM is not supported.
if (CMAKE_SIZEOF_VOID_P EQUAL 8)
    FIND_LIBRARY(OEM7_DECODER_LIB liboem7decoder.a "novatel_oem7/bin/amd64") 
else (CMAKE_SIZEOF_VOID_P EQUAL 8)
    FIND_LIBRARY(OEM7_DECODER_LIB liboem7decoder.a "novatel_oem7/bin/i386") 
endif (CMAKE_SIZEOF_VOID_P EQUAL 8)

message(STATUS "Linking to Oem7 Decoder at: '${OEM7_DECODER_LIB}'")

target_link_libraries(${PROJECT_NAME}
   ${catkin_LIBRARIES}
   ${Boost_LIBRARIES}
   ${OEM7_DECODER_LIB}
)


#############
## Install ##
#############

# all install targets should use catkin DESTINATION variables
# See http://ros.org/doc/api/catkin/html/adv_user_guide/variables.html


## Mark executables and/or libraries for installation
install(TARGETS ${PROJECT_NAME} 
   ARCHIVE DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
   LIBRARY DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
   RUNTIME DESTINATION ${CATKIN_PACKAGE_BIN_DESTINATION}
)

## Export plugin header files.
install(DIRECTORY include/${PROJECT_NAME}/
   DESTINATION ${CATKIN_PACKAGE_INCLUDE_DESTINATION}
   FILES_MATCHING PATTERN "*.h" PATTERN "*.hpp"
)

## Mark other files for installation (e.g. launch and bag files, etc.)
install(
   FILES novatel_oem7_driver_nodelets.xml novatel_oem7_driver_plugins.xml
   DESTINATION ${CATKIN_PACKAGE_SHARE_DESTINATION}
 )

install(
   DIRECTORY 
   launch DESTINATION ${CATKIN_PACKAGE_SHARE_DESTINATION}
 )

install(
   DIRECTORY 
   config DESTINATION ${CATKIN_PACKAGE_SHARE_DESTINATION}
 )
 

#############
## Testing ##
#############

# Built-in Self Test (BIST)
catkin_install_python(PROGRAMS test/oem7_bist.py test/oem7_message_test.py
 	DESTINATION ${CATKIN_PACKAGE_SHARE_DESTINATION})
# Instaleld into SHARED vs BINARY. BINARY does not allow BIST to be run using
# rostest novatel_oem7_driver your_launch_file.lauch" syntax.


if (CATKIN_ENABLE_TESTING)
	find_package(rostest REQUIRED)
	add_rostest(test/align.test)
	add_rostest(test/bestpos.test)
	add_rostest(test/ins1.test)
	add_rostest(test/ins2.test)
	add_rostest(test/rxstatus.test)
	add_rostest(test/time.test)
endif()


#message("includes:")
#get_property(incdirs DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR} PROPERTY INCLUDE_DIRECTORIES)
#foreach(dir ${incdirs})
#   message(STATUS "incdir= '${dir}'")
#endforeach()

=== debian/changelog ===
ros-melodic-novatel-oem7-driver (1.1.0-1stretch) stretch; urgency=high

  * Autogenerated, no changelog for this version found in CHANGELOG.rst.

 -- NovAtel Support <support@novatel.com>  Sun, 03 May 2020 06:11:54 -0000

=== debian/control ===
Source: ros-melodic-novatel-oem7-driver
Section: misc
Priority: optional
Maintainer: NovAtel Support <support@novatel.com>
Build-Depends: debhelper (>= 9.0.0), libboost-all-dev, ros-melodic-catkin, ros-melodic-gps-common, ros-melodic-nodelet, ros-melodic-novatel-oem7-msgs, ros-melodic-roscpp, ros-melodic-rostest, ros-melodic-sensor-msgs, ros-melodic-tf
Homepage: http://www.novatel.com
Standards-Version: 3.9.2

Package: ros-melodic-novatel-oem7-driver
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libboost-all-dev, ros-melodic-gps-common, ros-melodic-nodelet, ros-melodic-novatel-oem7-msgs, ros-melodic-roscpp, ros-melodic-sensor-msgs, ros-melodic-tf
Description: NovAtel Oem7 ROS Driver

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/melodic/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG

%:
	dh $@ -v --buildsystem=cmake

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/melodic/setup.sh" ]; then . "/opt/ros/melodic/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCATKIN_BUILD_BINARY_PACKAGE="1" \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/melodic" \
		-DCMAKE_PREFIX_PATH="/opt/ros/melodic"

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/melodic/setup.sh" ]; then . "/opt/ros/melodic/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/melodic/setup.sh" ]; then . "/opt/ros/melodic/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/melodic/setup.sh" ]; then . "/opt/ros/melodic/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-melodic-novatel-oem7-driver//opt/ros/melodic/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/melodic/setup.sh" ]; then . "/opt/ros/melodic/setup.sh"; fi && \
	dh_auto_install

## ros-melodic-novatel-oem7-driver 4.2.0

=== debian/changelog ===
ros-melodic-novatel-oem7-driver (4.2.0-1bionic) bionic; urgency=high

  * Autogenerated, no changelog for this version found in CHANGELOG.rst.

 -- NovAtel Support <support.novatel@hexagon.com>  Tue, 14 Mar 2023 19:18:53 -0000

ros-melodic-novatel-oem7-driver (4.0.0-1bionic) bionic; urgency=high

  * Adding new messages
  * Support BESTGNSSPOS log topic publish

 -- NovAtel Support <support.novatel@hexagon.com>  Fri, 04 Mar 2022 07:00:00 -0000

ros-melodic-novatel-oem7-driver (3.0.0-1bionic) bionic; urgency=high

  * Adding new messages
  * Support PPPPOS, TERRASTARSTATUS, TERRASTARINFO log topic publish

 -- NovAtel Support <support.novatel@hexagon.com>  Wed, 23 Feb 2022 07:00:00 -0000

ros-melodic-novatel-oem7-driver (2.2.0-1bionic) bionic; urgency=high

  * No feature changes
  * More robust support for compillation for 32 vs. 64 bit targets

 -- NovAtel Support <support.novatel@hexagon.com>  Wed, 03 Feb 2021 07:00:00 -0000

ros-melodic-novatel-oem7-driver (2.1.0-1bionic) bionic; urgency=high

  * Support for ARM builds: arm32v7, arm64v8 (#1 <https://github.com/novatel/novatel_oem7_driver/issues/1>)
  * Initialization command mechanism robustness improvements

 -- NovAtel Support <support.novatel@hexagon.com>  Thu, 28 Jan 2021 07:00:00 -0000

ros-melodic-novatel-oem7-driver (2.0.0-1bionic) bionic; urgency=high

  * Support logging 'unknown' OEM7 messages under Oem7Raw topic
  * Populate gps_common/GPSStatus.status with more detailed status info
  * Source gps_common/GPSFix, gps_common/NavSatFix position data from the most recent and higher quality
    INSPVAS or BESTPOS/BESTVEL messsage.Previously, position data was always sourced from BESTPOS/BESTVEL, which is transmitted
    at lower rate than INSPVAS
    (#13 <https://github.com/novatel/novatel_oem7_driver/issues/13>)
  * Support nmea_msgs/Sentence for all OEM7 NMEA0183 messages (#4 <https://github.com/novatel/novatel_oem7_driver/issues/4>)
  * Support nav_msgs/Odometry, with position and orientation populated based on BESTPOS/BESTVEL/INSPVAS
    (#8 <https://github.com/novatel/novatel_oem7_driver/issues/8>)

 -- NovAtel Support <support.novatel@hexagon.com>  Fri, 18 Dec 2020 07:00:00 -0000

ros-melodic-novatel-oem7-driver (1.1.0-1bionic) bionic; urgency=high

  * No feature changesBuild fixes and documentation improvements.

 -- NovAtel Support <support.novatel@hexagon.com>  Sat, 02 May 2020 06:00:00 -0000

ros-melodic-novatel-oem7-driver (1.0.0-1bionic) bionic; urgency=high

  * Initial release

 -- NovAtel Support <support.novatel@hexagon.com>  Mon, 20 Apr 2020 06:00:00 -0000

=== debian/control ===
Source: ros-melodic-novatel-oem7-driver
Section: misc
Priority: optional
Maintainer: NovAtel Support <support.novatel@hexagon.com>
Build-Depends: debhelper (>= 9.0.0), libboost-all-dev, ros-melodic-catkin, ros-melodic-gps-common, ros-melodic-nav-msgs, ros-melodic-nmea-msgs, ros-melodic-nodelet, ros-melodic-novatel-oem7-msgs, ros-melodic-rosbag <!nocheck>, ros-melodic-roscpp, ros-melodic-rostest <!nocheck>, ros-melodic-sensor-msgs, ros-melodic-tf2-geometry-msgs
Homepage: http://www.novatel.com
Standards-Version: 3.9.2

Package: ros-melodic-novatel-oem7-driver
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libboost-all-dev, ros-melodic-gps-common, ros-melodic-nav-msgs, ros-melodic-nmea-msgs, ros-melodic-nodelet, ros-melodic-novatel-oem7-msgs, ros-melodic-roscpp, ros-melodic-sensor-msgs, ros-melodic-tf2-geometry-msgs
Description: NovAtel Oem7 ROS Driver

=== debian/rules ===
--- 
+++ 
@@ -17,9 +17,14 @@
 # Explicitly enable -DNDEBUG, see:
 # 	https://github.com/ros-infrastructure/bloom/issues/327
 export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG
+ifneq ($(filter nocheck,$(DEB_BUILD_OPTIONS)),)
+	BUILD_TESTING_ARG=-DBUILD_TESTING=OFF -DCATKIN_ENABLE_TESTING=OFF
+endif
+
+DEB_HOST_GNU_TYPE ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)
 
 %:
-	dh $@ -v --buildsystem=cmake
+	dh $@ -v --buildsystem=cmake --builddirectory=.obj-$(DEB_HOST_GNU_TYPE)
 
 override_dh_auto_configure:
 	# In case we're installing to a non-standard location, look for a setup.sh
@@ -29,7 +34,8 @@
 	dh_auto_configure -- \
 		-DCATKIN_BUILD_BINARY_PACKAGE="1" \
 		-DCMAKE_INSTALL_PREFIX="/opt/ros/melodic" \
-		-DCMAKE_PREFIX_PATH="/opt/ros/melodic"
+		-DCMAKE_PREFIX_PATH="/opt/ros/melodic" \
+		$(BUILD_TESTING_ARG)
 
 override_dh_auto_build:
 	# In case we're installing to a non-standard location, look for a setup.sh
